VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "modClip"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const CF_UNICODETEXT    As Long = 13&
Private Declare Function OpenClipboard Lib "user32.dll" (ByVal hWnd As Long) As Long
Private Declare Function SetClipboardData Lib "user32.dll" (ByVal wFormat As Long, ByVal hMem As Long) As Long
Private Declare Function GetClipboardData Lib "user32.dll" (ByVal wFormat As Long) As Long
Private Declare Function GlobalSize Lib "kernel32.dll" (ByVal hMem As Long) As Long
Private Declare Function GlobalLock Lib "kernel32.dll" (ByVal hMem As Long) As Long
Private Declare Function GlobalUnlock Lib "kernel32.dll" (ByVal hMem As Long) As Long
Private Declare Function lstrcpyn Lib "kernel32.dll" Alias "lstrcpynW" (ByVal lpDst As Long, ByVal lpSrc As Long, ByVal iMaxLength As Long) As Long
Private Declare Function CloseClipboard Lib "user32.dll" () As Long
Private Declare Sub Sleep Lib "kernel32.dll" (ByVal dwMilliseconds As Long)

Private vTypeGet As Long
Private vTypeSet As Long

'Enum Types
'
'vbCFBitmap
'vbCFDIB
'vbCFEMetafile
'vbCFFiles
'vbCFLink
'vbCFMetafile
'vbCFPalette
'vbCFRTF
'vbCFText

Private Sub Class_Initialize()
    vTypeGet = vbCFText
    vTypeSet = vbCFText
End Sub

'Type which we need to Get from ClipBoard
Public Property Let TypeGet(n As Long)
    vTypeGet = n
End Property

Public Property Get TypeGet() As Long
    TypeGet = vTypeGet
End Property

'Type of ClipBoard Data which we need to Set with value
Public Property Let TypeSet(n As Long)
    vTypeSet = n
End Property

Public Property Get TypeSet() As Long
    TypeSet = vTypeSet
End Property

'Put Data into ClipBoard
Public Property Let ClipPut(st As String)
    Clipboard.SetText st, vTypeSet
End Property

'Gain Data from Clipboard
'Public Property Get ClipGet()
'    If Clipboard.GetFormat(vTypeGet) Then
'        ClipGet = Clipboard.GetText(vTypeGet)
'    End If
'End Property
Public Function ClipGet(hWndOwner As Long) As String
    Dim hMem As Long
    Dim ptr  As Long
    Dim Size As Long
    Dim txt  As String
    If OpenClipboardEx(hWndOwner) Then
        hMem = GetClipboardData(CF_UNICODETEXT)
        If hMem Then
            Size = GlobalSize(hMem)
            If Size Then
                txt = Space$(Size \ 2 - 1)
                ptr = GlobalLock(hMem)
                lstrcpyn ByVal StrPtr(txt), ByVal ptr, Size
                GlobalUnlock hMem
                ClipGet = txt
            End If
        End If
        CloseClipboard
    End If
End Function

Public Function OpenClipboardEx(hWndOwner As Long) As Boolean 'thanks to wqweto
    Dim lr          As Long
    Dim lRetry      As Long
    
    Randomize Timer

    For lRetry = 1 To 5
        lr = OpenClipboard(hWndOwner)
        If lr <> 0 Then
            OpenClipboardEx = True
            Exit Function
        End If
        Call Sleep(Rnd() * 500)
    Next
End Function
